#include <gtk/gtk.h>
#include <mysql.h>

#include "support.h"

/* stdio.h is needed for the file read operation. */

#include <stdio.h>

#define	SERVER	"einstein"
#define	LOGIN	"kbi_user"
#define PASS	"dengissa"
#define DB	"kbi"

GtkWidget *frm_kbi;

/* The following generic variables have worked fine in the past,
 * so to keep things simple, use them again...
 */

MYSQL		*conx;
MYSQL_RES	*result_set;
MYSQL_ROW	row;
gchar		*sql;
gchar		*user_login;

/* Begin Function Code... */

gboolean authenticate_user()
{

   g_print("Starting authenticate_user.\n");

   conx = mysql_init(0L);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"mysql_init problem");
        return FALSE;
     }
   /* else continue on... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_init ok");

   conx = mysql_real_connect(conx, SERVER, LOGIN, PASS, DB, 0, 0L, 0);
   
   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"mysql_real_connect problem");
        return FALSE;
     }
   /* else continue on... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_real_connect ok");

   /* Create the sql string to query the database for the 
    * currently user.
    */

   sql = g_strconcat("select * from tbl_authorized_users ",
                     "where user_name = '",
                     g_get_user_name(), "'", 0L);

   g_print("sql is %s\n", sql);

   /* Next, query tbl_authorized_users to see if the currently
    * logged in person is on the list.
    */

   if (mysql_query (conx, sql) != 0)
      {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"mysql_query problem");
        return FALSE;
      }
   /* else continue... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_query ok");

   result_set = mysql_store_result(conx);

   if (mysql_num_rows(result_set) != 1)
      {
         /* Somethings wrong here... */
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"mysql_num_rows problem");
        return FALSE;
      }
   /* else continue... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_num_rows ok");

   /* Therefore, if the code has reached this point, the user
    * is authorized to run this application.
    */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "user authenticated");

   mysql_free_result (result_set);
   mysql_close (conx);
  
   return TRUE;
}

void fill_lst_reports()
{
   GList *list_of_reports = 0L;

   conx = mysql_init(0L);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"mysql_init problem");
        return;
     }
   /* else continue on... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_init ok");

   conx = mysql_real_connect(conx, SERVER, LOGIN, PASS, DB, 0, 0L, 0);
   
   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"mysql_real_connect problem");
        return;
     }
   /* else continue on... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_real_connect ok");

   sql = "select * from tbl_reports";

   if (mysql_query (conx, sql) != 0)
      {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"mysql_query problem");
        mysql_close(conx);
        return;
      }
   /* else continue... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1, "mysql_query ok");

   result_set = mysql_store_result(conx);

   /* At this point, result_set holds a list of the reports that
    * are available to be viewed.  Create a GList structure to 
    * hold that list.
    */

   while (( row = mysql_fetch_row (result_set)) != 0)
     {
         GtkWidget *list_item;

         //g_print("Report name is %s\n", row[0]);

         list_item = gtk_list_item_new_with_label(row[0]);

         /* The reason for this next call is to associate the
          * name of the report with the list item in the GtkList
          * widget lst_reports.  The 3 parameters are the 
          * list item, the "key", and the data to be retrieved
          * when this object is queried for the key.  This is 
          * done to be able to retrieve the text of the item
          * selected in lst_reports.  See get_report_name() below
          * for the retrieval proceedures.
          */

         gtk_object_set_data(GTK_OBJECT(list_item), "rept_name", row[0]);

         list_of_reports = g_list_append(list_of_reports, 
                list_item);

     }

   /* Now a GList object called list_of_reports contains all the
    * report names returned by the sql statement.  Insert that
    * list into lst_reports.
    */

   gtk_list_append_items(GTK_LIST(lookup_widget(frm_kbi, "lst_reports")), 
             list_of_reports);
  
   mysql_close(conx);

   /* Refresh the form. */
   gtk_widget_show_all(frm_kbi);

}

gchar *get_report_name()
{
    GtkWidget *target_list;
    GList     *target_GList;
    GtkObject *list_item;

    g_print("starting get_report_name.\n");

    target_list = lookup_widget(frm_kbi, "lst_reports");
    target_GList = GTK_LIST(target_list)->selection;

    if (target_GList)
      {
       g_print("target_GList populated.\n"); 
      }
    else 
      {
       g_print("target_GList not populated.\n");
       return "";
      }

    g_print("target_label identified.\n"); 

    list_item = GTK_OBJECT(target_GList->data);

    g_print("data item identified.\n");

    /* Now that there is a pointer to the selected list item,
     * query that object for the data associated with the 
     * object, in this case the report name.  In the following
     * call, "rept_data" acts as a key to retrieve a specific
     * peice of data from list_item.  See fill_list_reports() above
     * for the specifics of attaching data to an object.
     */

    return gtk_object_get_data(list_item, "rept_name");
}

gchar *get_exe_name(gchar *rept_name)
{
   g_print("Starting get_exe_name\n");

   sql = g_strconcat("select exe_name from tbl_reports where report_name = '",
                      rept_name, "'", 0L);

   conx = mysql_init(0L);
   conx = mysql_real_connect(conx, SERVER, LOGIN, PASS, DB, 0, 0L, 0);
   if (mysql_query (conx, sql) != 0)
       {
           /* Error, malformed sql... */
           gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_kbi,
                      "statusbar1")), 1,"mysql_query problem in get_exe_name");
        mysql_close(conx);
        return "";
       }

   result_set = mysql_store_result(conx);

   row = mysql_fetch_row (result_set);

   mysql_free_result(result_set);
   mysql_close(conx);
   return row[0];
}

gboolean check_file_exists(target_file)
{
   /* If a file does not exist, the fopen call returns
    * Null (0L).  The "r" parameter is for "read only".
    */
 
   g_print("Starting check_file_exists.\n");

   if ( fopen((char*) target_file, "r") == 0L )
      {
         g_print("File does not exist.\n");
         return FALSE;
      }
   else
      /* File does exist. */
      g_print("File does exist.\n");

   return TRUE;
}
