#include <gtk/gtk.h>
#include <mysql.h>

/* stdlib.h is needed for the atoi/atof call. */

#include <stdlib.h>

#include "support.h"

#define	SERVER  "einstein"
#define	LOGIN   "com_user"
#define PASS    "syL0U812"
#define DB      "commish"

#define HORIZONTAL_LINE 550
#define VERTICAL_LINE    40

GtkWidget *frm_scatter;

MYSQL           *conx;
MYSQL_RES       *result_set;
MYSQL_ROW       row;
gchar           *sql;

gint    vertical_index;
gint    horizontal_index;

gint max_vertical = 0;
gint max_horizontal = 0;

gdouble vertical_scale_multiplier = 1.0;
gdouble horizontal_scale_multiplier = 1.0;

void set_indices();
gboolean load_data();

GdkGC *get_gc(gchar *in_color)
{
   /* This is the same get_gc() from the bar/line report. */

   GdkGC    *gc;
   GdkColor my_color;

   gc = gdk_gc_new(GTK_WIDGET(lookup_widget(frm_scatter,
           "drawingarea1"))->window);

   if (!gdk_color_parse(in_color, &my_color))
      {
         g_print("Unable to parse %s.\n", in_color);
         gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
               "statusbar1")), 1, "Unable to parse color.\n");
         return 0L;
      }

   if (!gdk_colormap_alloc_color(gdk_colormap_get_system(),
        &my_color, FALSE, TRUE))

      {
         g_print("Unable to allocate colormap for %s.\n", in_color);
         gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
               "statusbar1")), 1, "Unable to allocate colormap.\n");
         return 0L;
      }
  
   gdk_gc_set_foreground(gc, &my_color);
 
   return gc;

}

void draw_axis_and_scales()
{
   GdkGC    *gc;

   gc = get_gc("Black");

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       gc, 25, HORIZONTAL_LINE, "0"); 

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       gc, 45, HORIZONTAL_LINE + 15, "0"); 
   

   gdk_draw_line(
           GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
           gc, VERTICAL_LINE, 10, VERTICAL_LINE, HORIZONTAL_LINE);

   gdk_draw_line(
           GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
           gc, VERTICAL_LINE, HORIZONTAL_LINE, 875, HORIZONTAL_LINE);

}

void plot_point(gint from_left, gint from_bottom, gchar *legend)
{
    gdk_draw_rectangle(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       get_gc("Black"), FALSE, from_left, from_bottom - 3, 3, 3);

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       get_gc("Black"), from_left + 4, from_bottom + 2, legend); 
}

void set_maximums()
{
    /* Reset result_set to point to the first row of the data;
     * 0 is the first row in a zero-based structure.
     */

    mysql_data_seek(result_set, 0);

    while (( row = mysql_fetch_row (result_set)) != 0)
        {
            if (atoi (row[vertical_index]) > max_vertical)
               {
                  max_vertical = atoi(row[vertical_index]);
                  g_print("max_vertical is now %d\n", max_vertical);
               }
        }
    vertical_scale_multiplier = (gdouble) 540/max_vertical;
    g_print("vertical_scale_multiplier is %f\n", vertical_scale_multiplier);

    mysql_data_seek(result_set, 0);

    while (( row = mysql_fetch_row (result_set)) != 0)
        {
            if (atoi (row[horizontal_index]) > max_horizontal)
               {
                  max_horizontal = atoi(row[horizontal_index]);
                  g_print("max_horizontal is now %d\n", max_horizontal);
               }
        }
    horizontal_scale_multiplier = (gdouble) 835/max_horizontal;
    g_print("horizontal_scale_multiplier is %f\n", horizontal_scale_multiplier);
}

void plot_maximums()
{
   GdkGC    *gc;

   gc = get_gc("Black");

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       gc, 0, 10, g_strdup_printf("%d", max_vertical)); 

   gdk_draw_string(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->style->font,
       gc, 845, HORIZONTAL_LINE + 15, g_strdup_printf("%d", max_horizontal)); 

}

void plot_graph()
{
    gint i = 0;

    gdk_draw_rectangle(
       GTK_WIDGET(lookup_widget(frm_scatter, "drawingarea1"))->window,
       get_gc("Gray"), TRUE, 0, 0, 900, 575);

    load_data();
    draw_axis_and_scales();
    set_indices();
    set_maximums();
    plot_maximums();

    mysql_data_seek(result_set, 0);

    while (( row = mysql_fetch_row (result_set)) != 0)
      {
        /*g_print("vertical is %s and horiz is %s\n", row[vertical_index],
         *       row[horizontal_index]);
         */

        plot_point(VERTICAL_LINE + 
                     atoi(row[horizontal_index])*horizontal_scale_multiplier,
                   HORIZONTAL_LINE - 
                     atoi(row[vertical_index])*vertical_scale_multiplier,
                   row[0]);

        i++;
      }

    //plot_point(VERTICAL_LINE + 10, HORIZONTAL_LINE - 100, "10 from left");
    //plot_point(VERTICAL_LINE + 100, HORIZONTAL_LINE - 10, "100 from left");
}

void set_indices()
{
    /* Set the variables horizontal_index and vertical_index
     * so the software knows which columns in result_set to
     * plot.
     */

    GtkCombo  *cbo;
    gchar     *cbo_text;

    cbo = GTK_COMBO(lookup_widget(frm_scatter, "cbo_vertical"));
    cbo_text = gtk_entry_get_text(GTK_ENTRY(cbo->entry)); 
    g_print("vertical axis is %s\n", cbo_text);

    if (g_strcasecmp(cbo_text, "Order Quantity") == 0) 
         vertical_index = 1;
    else if (g_strcasecmp(cbo_text, "Unit Price") == 0) 
         vertical_index = 2;
    else if (g_strcasecmp(cbo_text, "Net Value") == 0) 
         vertical_index = 3;
    else if (g_strcasecmp(cbo_text, "Invoice Quantity") == 0) 
         vertical_index = 4;
    else if (g_strcasecmp(cbo_text, "Invoice Value") == 0) 
         vertical_index = 5;
    else vertical_index = -1;            

    g_print("vertical_index is %d\n", vertical_index);

    cbo = GTK_COMBO(lookup_widget(frm_scatter, "cbo_horizontal"));
    cbo_text = gtk_entry_get_text(GTK_ENTRY(cbo->entry)); 
    g_print("horizontal axis is %s\n", cbo_text);

    if (g_strcasecmp(cbo_text, "Order Quantity") == 0) 
         horizontal_index = 1;
    else if (g_strcasecmp(cbo_text, "Unit Price") == 0) 
         horizontal_index = 2;
    else if (g_strcasecmp(cbo_text, "Net Value") == 0) 
         horizontal_index = 3;
    else if (g_strcasecmp(cbo_text, "Invoice Quantity") == 0) 
         horizontal_index = 4;
    else if (g_strcasecmp(cbo_text, "Invoice Value") == 0) 
         horizontal_index = 5;
    else horizontal_index = -1;          
 
    g_print("horizontal_index is %d\n", horizontal_index);

}

gboolean load_data()
{

   static gboolean already_loaded = FALSE;

   if (already_loaded)
     {
        g_print("Data has been previously loaded.\n");
        return TRUE;
     }

   conx = mysql_init(0L);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1,"mysql_init problem");
        return FALSE;
     }
   /* else continue on... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1, "mysql_init ok");

   conx = mysql_real_connect(conx, SERVER, LOGIN, PASS, DB, 0, 0L, 0);

   if (conx == 0L)
     {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1,"mysql_real_connect problem");
        return FALSE;
     }
   /* else continue on... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1, "mysql_real_connect ok");

   sql = g_strconcat("select line_number, order_quantity, ",
                     "       unit_price, net_value, ",
                     "       invoice_quantity, invoice_value ",
                     "  from tbl_revenue ",
                     "  order by line_number", 0L);

   g_print("sql is %s\n", sql);

   if (mysql_query (conx, sql) != 0)
      {
        gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1,"mysql_query problem");
        g_print("mysql_query problem in load_data.\n");
        mysql_close(conx);
        return FALSE;
      }
   /* else continue... */

   gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(frm_scatter,
                      "statusbar1")), 1, "mysql_query ok");

   result_set = mysql_store_result(conx);

   mysql_close(conx);

   already_loaded = TRUE;
   return TRUE;

}
