# The spec file for building the rpm to distribute the 
# KBI Application built in Chapters 10, 11, and 12.

# The Preamble Section

Summary:  Key Business Applications
Name: kbi
Version: 0.1
Release: 1
Copyright: Proprietary
Group:  Applications/Databases
Packager:  Matt Stucky <stuckym@prodigy.net>

%description
In house application for exective reporting on "key business
indicators"

# Preparation Section

%prep

# Clean out the rpm build and source directories in preparation for
# the build.

rm -rf $RPM_BUILD_DIR/*
rm -rf $RPM_SOURCE_DIR/*

cp /mnt/DOS_hda2/newriders/book/ch12/kbi/src/kbi            $RPM_BUILD_DIR
cp /mnt/DOS_hda2/newriders/book/ch12/r1/src/tabular         $RPM_BUILD_DIR
cp /mnt/DOS_hda2/newriders/book/ch12/r2/src/pie             $RPM_BUILD_DIR
cp /mnt/DOS_hda2/newriders/book/ch12/r3/src/bar_line        $RPM_BUILD_DIR
cp /mnt/DOS_hda2/newriders/book/ch12/r4/src/scatter         $RPM_BUILD_DIR
cp "/mnt/DOS_hda2/newriders/book/ch12/kbi/src/Key Business Indicators.desktop" $RPM_BUILD_DIR 

# These next two sections are simple having already created the
# make file with a "make install" included.

%build

# This application will not distribute the source.
# Therefore, there is no source to build.

%install
# Unlike the previous RPM spec file, this one has no "make install"
# because it distributes several packages in binary only.

pwd

cp kbi       /usr/local/bin
cp tabular   /usr/local/bin
cp pie       /usr/local/bin
cp bar_line  /usr/local/bin
cp scatter   /usr/local/bin
cp "Key Business Indicators.desktop" "/usr/share/gnome/apps/In House Applications"

pwd

# Lastly, a list of the files needed for the application to install.

%files
/usr/local/bin/kbi
/usr/local/bin/tabular
/usr/local/bin/pie
/usr/local/bin/bar_line
/usr/local/bin/scatter
"/mnt/DOS_hda2/newriders/book/ch12/kbi/src/Key Business Indicators.desktop" 


